import sys
import math
import itertools

import cv2

import search
import viz

####################
####################

# Write any functions you need here

####################
####################

# Visually solves a supplied maze image (using a variety of search methods)
# 
# Expects... python image.py <path to maze image> <pooling multiplier> [search method]
def main(argv):
	mazepath = argv[0]
	multiplier = int(argv[1])
	method = argv[2] if len(argv) > 2 and argv[2] in search.METHODS_MAP else None
	colors = viz.COST_KWRGB

	# 1. read the original image (visualize for debugging)
	
	# 2. pre-process the image, including cropping & max-pooling
	#    according to the supplied multiplier 
	#    (visualize after each step for debugging)

	# 3. convert to maze representation: a list-of-lists, start, finish
	#    (visualize for debugging)

	# 4. solve the resulting maze using the desired search method,
	#    or all methods if none is supplied
	#    (visualize the solved maze, as well as super-impose the
	#    path on the original image)

	# 5. clean up!
	viz.close()
	
# Runs from the command line
if __name__ == "__main__":
	main(sys.argv[1:])
